var CLT_CustomFormatBuffer = null;

function CLT_ClearCustomFormat()
{
	window.opener.CLT_CustomFormatLabel = null;
	window.opener.CLT_CustomFormatFormat = null;
	window.opener.CLT_CustomFormatRichText = null;
}

function CLT_InitCustomFormat()
{
	var stringBundle = document.getElementById("CLT-String-Bundle");

	if(window.arguments[0] == "add")
		document.title = stringBundle.getString("CLT_AddCustomFormat");
	else
	{
		document.title = stringBundle.getString("CLT_EditCustomFormat");

		document.getElementById("CLT-Custom-Format-Label").value = window.arguments[1];
		document.getElementById("CLT-Custom-Format-Format").value = window.arguments[2];

		if(window.arguments[2] == CLT_RichTextFormatLabel)
			document.getElementById("CLT-Custom-Format-RichText").checked = true;
	}

	CLT_UpdateCustomFormatControls();
}

function CLT_OnCustomFormatLink()
{
	var url = "http://www.borngeek.com/firefox/colt/custom-formats/";
	
	var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	var currentWindow = windowMediator.getMostRecentWindow("navigator:browser");
	if (currentWindow)
	{
		try
		{
			currentWindow.delayedOpenTab(url);
		}
		catch(e)
		{
			currentWindow.loadURI(url);
		}
	}
	else
	{
		var protocolService = Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
																		.getService(Components.interfaces.nsIExternalProtocolService);
		var uri = Components.classes["@mozilla.org/network/io-service;1"]
												.getService(Components.interfaces.nsIIOService)
												.newURI(url, null, null);
		protocolService.loadURI(uri, null);
	}
}

function CLT_SaveCustomFormat()
{
	var stringBundle = document.getElementById("CLT-String-Bundle");
	
	var label = CLT_Trim(document.getElementById("CLT-Custom-Format-Label").value);
	var format = CLT_Trim(document.getElementById("CLT-Custom-Format-Format").value);
	var richText = document.getElementById("CLT-Custom-Format-RichText").checked;
	var errors = "";

	if(!label)
		errors += stringBundle.getString("CLT_EmptyLabel") + "\n";

	if(!richText && !format)
		errors += stringBundle.getString("CLT_EmptyFormat") + "\n";

	if(errors)
	{
		Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService).alert(null, stringBundle.getString("CLT_ErrorMessage"), errors);
		return false;
	}
	else
	{
		window.opener.CLT_CustomFormatLabel = label;
		window.opener.CLT_CustomFormatFormat = format;
		window.opener.CLT_CustomFormatRichText = richText;
		return true;
	}
}

function CLT_UpdateCustomFormatControls()
{
	if(CLT_CustomFormatBuffer == null)
		CLT_CustomFormatBuffer = document.getElementById("CLT-Custom-Format-Format").value;

	if(document.getElementById("CLT-Custom-Format-RichText").checked)
	{
		document.getElementById("CLT-Custom-Format-Format").disabled = true;
		document.getElementById("CLT-Custom-Format-Format").value = CLT_RichTextFormatLabel;
	}
	else
	{
		document.getElementById("CLT-Custom-Format-Format").disabled = false;

		if(CLT_CustomFormatBuffer == CLT_RichTextFormatLabel)
			document.getElementById("CLT-Custom-Format-Format").value = "";
		else
			document.getElementById("CLT-Custom-Format-Format").value = CLT_CustomFormatBuffer;
	}
}
